/* 
(C) OOMusou 2008 http://oomusou.cnblogs.com

Filename    : DE2_70.v
Compiler    : Quartus II 8.1
Description : Demo how to use TRDB-D5M with LTM on DE2-70 with Nios II
Release     : 12/18/2008 1.0
*/

`default_nettype none

module DE2_70 (
  //////////////////////// Clock Input ////////////////////////
  input          iCLK_28,           // 28.63636 MHz
  input          iCLK_50,           // 50 MHz
  input          iCLK_50_2,         // 50 MHz
  input          iCLK_50_3,         // 50 MHz
  input          iCLK_50_4,         // 50 MHz
  input          iEXT_CLOCK,        // External Clock
  //////////////////////// Push Button ////////////////////////
  input  [3:0]   iKEY,              // Pushbutton[3:0]
  //////////////////////// DPDT Switch ////////////////////////
  input  [17:0]  iSW,               // Toggle Switch[17:0]
  //////////////////////// 7-SEG Dispaly ////////////////////////
  output [6:0]   oHEX0_D,           // Seven Segment Digit 0
  output [6:0]   oHEX1_D,           // Seven Segment Digit 1
  output [6:0]   oHEX2_D,           // Seven Segment Digit 2
  output [6:0]   oHEX3_D,           // Seven Segment Digit 3
  output [6:0]   oHEX4_D,           // Seven Segment Digit 4
  output [6:0]   oHEX5_D,           // Seven Segment Digit 5
  output [6:0]   oHEX6_D,           // Seven Segment Digit 6
  output [6:0]   oHEX7_D,           // Seven Segment Digit 7
  //////////////////////////// LED ////////////////////////////
  output [8:0]   oLEDG,             // LED Green[8:0]
  output [17:0]  oLEDR,             // LED Red[17:0]
  /////////////////////// SDRAM Interface ////////////////////////
  inout   [31:0] DRAM_DQ,           // SDRAM Data bus 32 Bits
  output  [12:0] oDRAM0_A,          // SDRAM0 Address bus 13 Bits
  output  [12:0] oDRAM1_A,          // SDRAM1 Address bus 13 Bits
  output         oDRAM0_LDQM0,      // SDRAM0 Low-byte Data Mask 
  output         oDRAM1_LDQM0,      // SDRAM1 Low-byte Data Mask 
  output         oDRAM0_UDQM1,      // SDRAM0 High-byte Data Mask
  output         oDRAM1_UDQM1,      // SDRAM1 High-byte Data Mask
  output         oDRAM0_WE_N,       // SDRAM0 Write Enable
  output         oDRAM1_WE_N,       // SDRAM1 Write Enable
  output         oDRAM0_CAS_N,      // SDRAM0 Column Address Strobe
  output         oDRAM1_CAS_N,      // SDRAM1 Column Address Strobe
  output         oDRAM0_RAS_N,      // SDRAM0 Row Address Strobe
  output         oDRAM1_RAS_N,      // SDRAM1 Row Address Strobe
  output         oDRAM0_CS_N,       // SDRAM0 Chip Select
  output         oDRAM1_CS_N,       // SDRAM1 Chip Select
  output  [1:0]  oDRAM0_BA,         // SDRAM0 Bank Address
  output  [1:0]  oDRAM1_BA,         // SDRAM1 Bank Address
  output         oDRAM0_CLK,        // SDRAM0 Clock
  output         oDRAM1_CLK,        // SDRAM1 Clock
  output         oDRAM0_CKE,        // SDRAM0 Clock Enable
  output         oDRAM1_CKE,        // SDRAM1 Clock Enable
  //////////////////////// Flash Interface ////////////////////////
  inout   [14:0] FLASH_DQ,          // FLASH Data bus 15 Bits (0 to 14)
  inout          FLASH_DQ15_AM1,    // FLASH Data bus Bit 15 or Address A-1
  output  [21:0] oFLASH_A,          // FLASH Address bus 26 Bits
  output         oFLASH_WE_N,       // FLASH Write Enable
  output         oFLASH_RST_N,      // FLASH Reset
  output         oFLASH_WP_N,       // FLASH Write Protect /Programming Acceleration 
  input          iFLASH_RY_N,       // FLASH Ready/Busy output 
  output         oFLASH_BYTE_N,     // FLASH Byte/Word Mode Configuration
  output         oFLASH_OE_N,       // FLASH Output Enable
  output         oFLASH_CE_N,       // FLASH Chip Enable
  //////////////////////// SRAM Interface ////////////////////////
  inout   [31:0] SRAM_DQ,           // SRAM Data Bus 32 Bits
  inout   [3:0]  SRAM_DPA,          // SRAM Parity Data Bus
  output  [18:0] oSRAM_A,           // SRAM Address bus 21 Bits
  output         oSRAM_ADSC_N,      // SRAM Controller Address Status 	
  output         oSRAM_ADSP_N,      // SRAM Processor Address Status
  output         oSRAM_ADV_N,       // SRAM Burst Address Advance
  output  [3:0]  oSRAM_BE_N,        // SRAM Byte Write Enable
  output         oSRAM_CE1_N,       // SRAM Chip Enable
  output         oSRAM_CE2,         // SRAM Chip Enable
  output         oSRAM_CE3_N,       // SRAM Chip Enable
  output         oSRAM_CLK,         // SRAM Clock
  output         oSRAM_GW_N,        // SRAM Global Write Enable
  output         oSRAM_OE_N,        // SRAM Output Enable
  output         oSRAM_WE_N,        // SRAM Write Enable
  //////////////////////// GPIO ////////////////////////////////
  inout   [31:0] GPIO_0,            // GPIO Connection 0 I/O
  input          GPIO_CLKIN_N0,     // GPIO Connection 0 Clock Input 0
  input          GPIO_CLKIN_P0,     // GPIO Connection 0 Clock Input 1
  inout          GPIO_CLKOUT_N0,    // GPIO Connection 0 Clock Output 0
  inout          GPIO_CLKOUT_P0,    // GPIO Connection 0 Clock Output 1
  inout   [31:0] GPIO_1,            // GPIO Connection 1 I/O
  input          GPIO_CLKIN_N1,     // GPIO Connection 1 Clock Input 0
  input          GPIO_CLKIN_P1,     // GPIO Connection 1 Clock Input 1
  inout          GPIO_CLKOUT_N1,    // GPIO Connection 1 Clock Output 0
  inout          GPIO_CLKOUT_P1,     // GPIO Connection 1 Clock Output 1
  ////////////////////	SD Card Interface	////////////////////////
  inout          SD_DAT,          	// SD Card Data
  inout          SD_DAT3,           // SD Card Data 3
  inout          SD_CMD,            // SD Card Command Signal
  output         oSD_CLK         		// SD Card Clock
);

// ltm
wire  [7:0] ltm_r;    // ltm red data 8 bits
wire  [7:0] ltm_g;    // ltm green data 8 bits
wire  [7:0] ltm_b;    // ltm blue data 8 bits
wire        ltm_nclk; // ltm clcok
wire        ltm_hd;   // ltm h.sync
wire        ltm_vd;   // ltm v.sync
wire        ltm_den;  // ltm data enable

// ltm config
wire        ltm_sclk;      // ltm I2S clk
wire        ltm_scen;      // ltm I2s clk enable
wire        adc_ltm_sclk;  // acd_ltm I2s clk enable
wire        ltm_grst;      // ltm reset

assign  ltm_grst        = iKEY[0];      // ltm rest
assign  adc_ltm_sclk    = ltm_sclk;     // ltm i2s clk enable
assign  GPIO_0[2]       = adc_ltm_sclk; // acd_ltm i2sclk enable
assign  GPIO_0[3]       = ltm_b[3];     // ltm blue data 8 bits
assign  GPIO_0[4]       = ltm_b[2];     // ltm blue data 8 bits
assign  GPIO_0[5]       = ltm_b[1];     // ltm blue data 8 bits
assign  GPIO_0[6]       = ltm_b[0];     // ltm blue data 8 bits
assign  GPIO_0[7]       =~ltm_nclk;     // ltm clcok
assign  GPIO_0[8]       = ltm_den;      // ltm data enable
assign  GPIO_0[9]       = ltm_hd;       // ltm h.sync
assign  GPIO_0[10]      = ltm_vd;       // ltm v.sync
assign  GPIO_0[11]      = ltm_b[4];     // ltm blue data 8 bits
assign  GPIO_0[12]      = ltm_b[5];     // ltm blue data 8 bits
assign  GPIO_0[13]      = ltm_b[6];     // ltm blue data 8 bits
assign  GPIO_CLKOUT_N0  = ltm_b[7];     // ltm blue data 8 bits
assign  GPIO_0[14]      = ltm_g[0];     // ltm blue data 8 bits
assign  GPIO_CLKOUT_P0  = ltm_g[1];     // ltm blue data 8 bits
assign  GPIO_0[15]      = ltm_g[2];     // ltm blue data 8 bits
assign  GPIO_0[16]      = ltm_g[3];     // ltm blue data 8 bits
assign  GPIO_0[17]      = ltm_g[4];     // ltm blue data 8 bits
assign  GPIO_0[18]      = ltm_g[5];     // ltm blue data 8 bits
assign  GPIO_0[19]      = ltm_g[6];     // ltm blue data 8 bits
assign  GPIO_0[20]      = ltm_g[7];     // ltm blue data 8 bits
assign  GPIO_0[21]      = ltm_r[0];     // ltm red data 8 bits
assign  GPIO_0[22]      = ltm_r[1];     // ltm red data 8 bits
assign  GPIO_0[23]      = ltm_r[2];     // ltm red data 8 bits
assign  GPIO_0[24]      = ltm_r[3];     // ltm red data 8 bits
assign  GPIO_0[25]      = ltm_r[4];     // ltm red data 8 bits
assign  GPIO_0[26]      = ltm_r[5];     // ltm red data 8 bits
assign  GPIO_0[27]      = ltm_r[6];     // ltm red data 8 bits 
assign  GPIO_0[28]      = ltm_r[7];     // ltm red data 8 bits
assign  GPIO_0[29]      = ltm_grst;     // ltm red data 8 bits 
assign  GPIO_0[30]      = ltm_scen;     // ltm sclk enable

// reset_delay
wire dly_rst_0; // reset delay 0
wire dly_rst_1; // reset delay 1
wire dly_rst_2; // reset delay 2

Reset_Delay reset0 (
  .iCLK(iCLK_50),     // 50 MHz
  .iRST(iKEY[0]),     // Pushbutton[0]
  .oRST_0(dly_rst_0), // reset delay 0
  .oRST_1(dly_rst_1), // reset delay 1
  .oRST_2(dly_rst_2)  // reset delay 2
);

// flash
wire flash_16bit_ip_a0;

assign oFLASH_BYTE_N = 1'b1;  // flash byte/word mode configuration
assign oFLASH_RST_N  = 1'b1;  // flash reset
assign oFLASH_WP_N   = 1'b1;  // flash write protect /programming acceleration 

// ssram
wire       sram_clk;          // sram clock
wire [1:0] sram_dummy_addr;   // used to ignore the a0/a1 pin from cypress ssram ip core
wire       sram_dummy_addr0;  // used to ignore msb of sram address

assign oSRAM_CLK    = sram_clk;      // sram clock
assign oSRAM_A[18]  = 1'bz;          // ignore oSRAM_A[18]
assign oSRAM_ADSP_N = 1'b1;          // sram processor address status
assign oSRAM_ADV_N  = 1'b1;          // sram burst address advance
assign oSRAM_CE2    = ~oSRAM_CE1_N;  // sram chip enable
assign oSRAM_CE3_N  = oSRAM_CE1_N;   // sram chip enable
assign oSRAM_GW_N   = 1'b1;          // sram global write enable

// sdram (dual channel)
// the sdram is shared with Hw and SW
wire [12:0] dram_a;      // sdram address
wire [1:0]  dram_ba;     // sdram bank address
wire        dram_cas_n;  // sdram column address strobe
wire        dram_cke;    // sdram clock enable
wire        dram_cs_n;   // sdram chip select
wire [3:0]  dram_dqm;    // sdram data mask
wire        dram_ras_n;  // sdram row address strobe
wire        dram_we_n;   // sdram write enable

// sdram0
assign oDRAM0_CLK   = sram_clk;     // sdram0 clock
assign oDRAM0_A     = dram_a;       // sdram0 address bus 13 bits
assign oDRAM0_BA    = dram_ba;      // sdram0 bank address
assign oDRAM0_CAS_N = dram_cas_n;   // sdram0 column address strobe
assign oDRAM0_CKE   = dram_cke;     // sdram0 clock enable
assign oDRAM0_CS_N  = dram_cs_n;    // sdram0 chip select
assign oDRAM0_LDQM0 = dram_dqm[0];  // sdram0 low-byte data mask 
assign oDRAM0_UDQM1 = dram_dqm[1];  // sdram0 high-byte data mask
assign oDRAM0_RAS_N = dram_ras_n;   // sdram0 row address strobe
assign oDRAM0_WE_N  = dram_we_n;    // sdram0 write enable

// sdram1
assign oDRAM1_CLK   = sram_clk;     // sdram1 clock
assign oDRAM1_A     = dram_a;       // sdram1 clock                   
assign oDRAM1_BA    = dram_ba;      // sdram1 address bus 13 bits     
assign oDRAM1_CAS_N = dram_cas_n;   // sdram1 bank address            
assign oDRAM1_CKE   = dram_cke;     // sdram1 column address strobe   
assign oDRAM1_CS_N  = dram_cs_n;    // sdram1 clock enable            
assign oDRAM1_LDQM0 = dram_dqm[2];  // sdram1 chip select             
assign oDRAM1_UDQM1 = dram_dqm[3];  // sdram1 low-byte data mask      
assign oDRAM1_RAS_N = dram_ras_n;   // sdram1 high-byte data mask     
assign oDRAM1_WE_N  = dram_we_n;    // sdram1 row address strobe      
                                    // sdram1 write enable

// LED
assign oLEDG[8]    = 1'b0;     // no use of ledg[8]
assign oLEDR[17:2] = 14'h0000; // no use of ledr[15:2]

// NIOS II CPU
wire cpu_clk;     // cpu clk
wire cpu_reset_n; // cpu reset

assign cpu_reset_n = dly_rst_2; // cpu_reset

nios_ii nios0 (
  // 1) global signals:
  .clk_50(iCLK_50),         // 50MHz
  .pll_c0_system(cpu_clk),  // cpu clk
  .pll_c1_memory(sram_clk), // sram clk
  .reset_n(cpu_reset_n),    // cpu reset
  // the_sdram
  .zs_addr_from_the_sdram(dram_a),       // sdram address
  .zs_ba_from_the_sdram(dram_ba),        // sdram bank address
  .zs_cas_n_from_the_sdram(dram_cas_n),  // sdram column address strobe
  .zs_cke_from_the_sdram(dram_cke),      // sdram clock enable
  .zs_cs_n_from_the_sdram(dram_cs_n),    // sdram chip select
  .zs_dq_to_and_from_the_sdram(DRAM_DQ), // sdram data bus 32 bits
  .zs_dqm_from_the_sdram(dram_dqm),      // sdram data mask
  .zs_ras_n_from_the_sdram(dram_ras_n),  // sdram row address strobe
  .zs_we_n_from_the_sdram(dram_we_n),    // sdram write enable
  // flash
  .address_to_the_cfi_flash({oFLASH_A[21:0],flash_16bit_ip_a0}), // flash address bus 26 bits
  .data_to_and_from_the_cfi_flash({FLASH_DQ15_AM1,FLASH_DQ}),    // flash data bus 15 bits (0 to 14)
  .read_n_to_the_cfi_flash(oFLASH_OE_N),                         // flash output enable 
  .select_n_to_the_cfi_flash(oFLASH_CE_N),                       // flash chip enable
  .write_n_to_the_cfi_flash(oFLASH_WE_N),                        // flash write enable
  // the_tristate_bridge_1_avalon_slave (ssram)
  .address_to_the_ssram({sram_dummy_addr0, oSRAM_A[17:0],sram_dummy_addr}), // sram address bus 21 bits
  .adsc_n_to_the_ssram(oSRAM_ADSC_N),                                       // sram controller address status
  .bw_n_to_the_ssram(oSRAM_BE_N),                                           // sram byte write enable 
  .bwe_n_to_the_ssram(oSRAM_WE_N),                                          // sram write enable
  .chipenable1_n_to_the_ssram(oSRAM_CE1_N),                                 // sram chip enable
  .data_to_and_from_the_ssram((SRAM_DQ)),                                   // sram data bus 32 bits
  .outputenable_n_to_the_ssram(oSRAM_OE_N),                                 // sram output enable
  // the_ltm0
  .coe_ltm_export_iCLK_50_to_the_ltm(iCLK_50_2),           // 50MHz
  .coe_ltm_export_iRST0_to_the_ltm(dly_rst_0),             // reset delay 0
  .coe_ltm_export_iRST2_to_the_ltm(dly_rst_2),             // reset delay 2
  .coe_ltm_export_oLTM_CLK_from_the_ltm(ltm_nclk),         // ltm clcok
  .coe_ltm_export_oR_from_the_ltm(ltm_r),                  // ltm red data 8 bits
  .coe_ltm_export_oG_from_the_ltm(ltm_g),                  // ltm green data 8 bits
  .coe_ltm_export_oB_from_the_ltm(ltm_b),                  // ltm blue data 8 bits
  .coe_ltm_export_oHD_from_the_ltm(ltm_hd),                // ltm h.sync
  .coe_ltm_export_oVD_from_the_ltm(ltm_vd),                // ltm v.sync
  .coe_ltm_export_oDEN_from_the_ltm(ltm_den),              // ltm data enable
  .coe_ltm_export_oSCLK_from_the_ltm(ltm_sclk),            // ltm sclk
  .coe_ltm_export_ioSDAT_to_and_from_the_ltm(GPIO_0[31]),  // ltm I2S data
  .coe_ltm_export_oSCEN_from_the_ltm(ltm_scen),            // ltm I2S clk enable
  .coe_ltm_export_oFIFO_EMPTY_from_the_ltm(oLEDR[0]),      // for debug use only (ltm fifo empty)
  .coe_ltm_export_oFIFO_FULL_from_the_ltm(oLEDR[1]),       // for debug use only (ltm fifo full)
  // SD
  .out_port_from_the_sd_clk(oSD_CLK),          // SD Card Clock
  .bidir_port_to_and_from_the_sd_cmd(SD_CMD),  // SD Card Command Signal
  .bidir_port_to_and_from_the_sd_dat(SD_DAT),  // SD Card Data
  .bidir_port_to_and_from_the_sd_dat3(SD_DAT3) // SD Card Data 3
);

endmodule
