#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include "bitmap.h"
#include "alt_types.h"  // alt_u32
#include "my_types.h"

#ifdef DEBUG_BMP
  #define BMP_DEBUG(x)    {myprintf x;}
#else
  #define BMP_DEBUG(x)
#endif

#define BMPWIDTH 800
#define BMPHEIGHT 480

BitmapHeader* get_bmp_header(alt_u8 *header) {
  BitmapHeader *bitmap = (BitmapHeader *)malloc(sizeof(BitmapHeader));
  
  memmove(bitmap->identity,header,2);
  memmove(&bitmap->file_size,header+2,4);
  memmove(&bitmap->reserved,header+6,4);
  memmove(&bitmap->RGB_data_offset,header+10,4);
  memmove(&bitmap->BITMAPINFOHEADER_size,header+14,4);
  memmove(&bitmap->width,header+18,4);
  memmove(&bitmap->height,header+22,4);
  memmove(&bitmap->planes,header+26,2);
  memmove(&bitmap->bit_per_pixel,header+28,2);
  memmove(&bitmap->compression,header+30,4);
  memmove(&bitmap->data_size,header+34,4);
  memmove(&bitmap->h_resolution,header+38,4);
  memmove(&bitmap->v_resolution,header+42,4);
  memmove(&bitmap->used_colors,header+46,4);
  memmove(&bitmap->important_colors,header+50,4);
  
  BMP_DEBUG(("BMP function getBMPHeader sucess!\n"));

  return bitmap;
}

// check bmp width, bmp height, RGB24, no compression
bool chk_valid_bmp(BitmapHeader *header) {
  if (header->width != BMPWIDTH || header->height != BMPHEIGHT || 
    header->RGB_data_offset != 54 || header->bit_per_pixel != 24 || 
    header->compression != 0 || header->BITMAPINFOHEADER_size != 40
  ) { 
    BMP_DEBUG(("BMP function check fail!\nBecause it is not I want BMP.\n"));
    return FALSE;
  }
  
  BMP_DEBUG(("BMP function check sucess!\n"));
  return TRUE;
}
